Package org.apache.tools.ant.types.resources

# Class TarResource

java.lang.Object
org.apache.tools.ant.ProjectComponent
org.apache.tools.ant.types.DataType
org.apache.tools.ant.types.Resource
org.apache.tools.ant.types.resources.ArchiveResource
org.apache.tools.ant.types.resources.TarResource

All Implemented Interfaces:
  `Cloneable`, `Comparable<Resource>`, `Iterable<Resource>`, `ResourceCollection`

public class TarResource extends ArchiveResource
A Resource representation of an entry in a tar archive.

Since:
  Ant 1.7

- ## Field Summary

  ### Fields inherited from class org.apache.tools.ant.types.Resource

  `MAGIC, UNKNOWN_DATETIME, UNKNOWN_SIZE`

  ### Fields inherited from class org.apache.tools.ant.types.DataType

  `checked, ref`

  ### Fields inherited from class org.apache.tools.ant.ProjectComponent

  `description, location, project`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `TarResource()`
  Default constructor.
  `TarResource(File a, TarEntry e)`
  Construct a TarResource representing the specified entry in the specified archive.
  `TarResource(Resource a, TarEntry e)`
  Construct a TarResource representing the specified entry in the specified archive.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `protected void`
  `fetchEntry()`
  fetches information from the named entry inside the archive.
  `int`
  `getGid()`
  Deprecated.
  `String`
  `getGroup()`
  `InputStream`
  `getInputStream()`
  Return an InputStream for reading the contents of this Resource.
  `byte`
  `getLinkFlag()`
  `String`
  `getLinkName()`
  `long`
  `getLongGid()`
  `long`
  `getLongUid()`
  `OutputStream`
  `getOutputStream()`
  Get an OutputStream for the Resource.
  `protected TarResource`
  `getRef()`
  Perform the check for circular references and return the referenced Resource.
  `int`
  `getUid()`
  Deprecated.
  `String`
  `getUserName()`

  ### Methods inherited from class org.apache.tools.ant.types.resources.ArchiveResource

  `addConfigured, checkEntry, compareTo, dieOnCircularReference, equals, getArchive, getLastModified, getMode, getSize, hashCode, isDirectory, isExists, setArchive, setMode, setRefid, toString`

  ### Methods inherited from class org.apache.tools.ant.types.Resource

  `as, asOptional, clone, getMagicNumber, getName, isFilesystemOnly, iterator, setDirectory, setExists, setLastModified, setName, setSize, size, toLongString`

  ### Methods inherited from class org.apache.tools.ant.types.DataType

  `checkAttributesAllowed, checkChildrenAllowed, circularReference, dieOnCircularReference, dieOnCircularReference, getCheckedRef, getCheckedRef, getCheckedRef, getCheckedRef, getCheckedRef, getDataTypeName, getRefid, invokeCircularReferenceCheck, isChecked, isReference, noChildrenAllowed, pushAndInvokeCircularReferenceCheck, setChecked, tooManyAttributes`

  ### Methods inherited from class org.apache.tools.ant.ProjectComponent

  `getDescription, getLocation, getProject, log, log, setDescription, setLocation, setProject`

  ### Methods inherited from class java.lang.Object

  `finalize, getClass, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface java.lang.Iterable

  `forEach, spliterator`

  ### Methods inherited from interface org.apache.tools.ant.types.ResourceCollection

  `isEmpty, stream`

- ## Constructor Details

  - ### TarResource

    public TarResource()
    Default constructor.

  - ### TarResource

    public TarResource(File a, TarEntry e)
    Construct a TarResource representing the specified entry in the specified archive.
    Parameters:
      `a` - the archive as File.
      `e` - the TarEntry.

  - ### TarResource

    public TarResource(Resource a, TarEntry e)
    Construct a TarResource representing the specified entry in the specified archive.
    Parameters:
      `a` - the archive as Resource.
      `e` - the TarEntry.

- ## Method Details

  - ### getInputStream

    public InputStream getInputStream() throws IOException
    Return an InputStream for reading the contents of this Resource.
    Overrides:
      `getInputStream` in class `Resource`
    Returns:
      an InputStream object.
    Throws:
      `IOException` - if the tar file cannot be opened, or the entry cannot be read.

  - ### getOutputStream

    public OutputStream getOutputStream() throws IOException
    Get an OutputStream for the Resource.
    Overrides:
      `getOutputStream` in class `Resource`
    Returns:
      an OutputStream to which content can be written.
    Throws:
      `IOException` - if unable to provide the content of this Resource as a stream.
      `UnsupportedOperationException` - if OutputStreams are not supported for this Resource type.

  - ### getUserName

    public String getUserName()
    Returns:
      the user name for the tar entry

  - ### getGroup

    public String getGroup()
    Returns:
      the group name for the tar entry

  - ### getLongUid

    public long getLongUid()
    Returns:
      the uid for the tar entry
    Since:
      1.10.4

  - ### getUid

    @Deprecated public int getUid()
    Deprecated.
    Returns:
      the uid for the tar entry

  - ### getLongGid

    public long getLongGid()
    Returns:
      the gid for the tar entry
    Since:
      1.10.4

  - ### getGid

    @Deprecated public int getGid()
    Deprecated.
    Returns:
      the uid for the tar entry

  - ### getLinkName

    public String getLinkName()
    Returns:
      the link "name" (=path) of this entry; an empty string if this is no link
    Since:
      1.10.12

  - ### getLinkFlag

    public byte getLinkFlag()
    Returns:
      the link "flag" (=type) of this entry
    Since:
      1.10.12

  - ### fetchEntry

    protected void fetchEntry()
    fetches information from the named entry inside the archive.
    Specified by:
      `fetchEntry` in class `ArchiveResource`

  - ### getRef

    protected TarResource getRef()
    Description copied from class: `Resource`
    Perform the check for circular references and return the referenced Resource.
    Overrides:
      `getRef` in class `ArchiveResource`
    Returns:
      `Resource`.